<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Hello!</title>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
  </head>
  <body>
    <image id="arrow" src="rocket.png" style="display: none"></image>
    <image id="angry" src="nu.png" style="display: none"></image>
    <canvas id="c" width="500" height="500"></canvas>
    <script>
      let canvas = document.getElementById("c");
      let ctx = canvas.getContext("2d");
      
      let components=[];
      
      function loop() {
        let life = true
        ctx.save();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        outer: for(let component of components){
          for(let _component of components){
            if(component != _component && component.alive && _component.alive){
              if(isOverlap(component,_component)){
                if(component.getType() == "MainComponent" && _component.getType() == "Obstacle"){
                  alert("fail");
                  alive = false;
                  life = false;
                  break outer;
                }
                else if(component.getType()=="Bullet" && _component.getType() == "Obstacle"){
                  component.alive=false;
                  _component.alive=false;
                }
              }
            }
          }
          component.update();
        }
        ctx.restore();
        if(life){
          window.requestAnimationFrame(loop);
        }
        
        
        
      }
      window.requestAnimationFrame(loop);
      
      class Component{
        constructor(x,y,width,height,fillStyle){
          this.x=x;
          this.y=y;
          this.width=width;
          this.height=height;
          this.fillStyle=fillStyle;
          this.alive = true;
        }
        getType(){}
        update(){
          if(this.alive){
            ctx.fillStyle=this.fillStyle;
            ctx.fillRect(this.x,this.y,this.width,this.height);
          }
          
          
        }
      }
      class MainComponent extends Component{
        constructor(x,y,width,height){
          super(x,y,width,height,"#ff91af");
        }
        getType(){
          return "MainComponent"
        }
        update(){
          let rocket = document.getElementById("arrow");
          ctx.drawImage(rocket,0,0,640,609,this.x,this.y,10,10)
        }
      }
      class Obstacle extends Component{
        constructor(x,y,width,height){
          super(x,y,width,height,"#000000");
        }
        getType(){
          return "Obstacle"
        }
        update(){
          let i=Math.random()
          super.update();
          this.y=this.y+i;
        }
      }
      class Bullet extends Component{
        constructor(x,y,width,height){
          super(x,y,width,height,"#ffffff");
        }
        getType(){
          return "Bullet"
        }
        update(){
          super.update();
          let angry = document.getElementById("angry");
          if(this.alive){
            ctx.drawImage(angry,0,0,300,300,this.x,this.y,29,29);
          }
          
      
          
          this.y=this.y-10;
        }
      }
      let mainComponent=new MainComponent(0,470,10,10);
      components.push(mainComponent);
      
      for(let i=0;i<=10;i++){
        let obstacle=new Obstacle(Math.floor(Math.random()*500),10,10,10);
        components.push(obstacle);
      }

      function onKeyDown(e){
        
        let keyCode=e.keyCode;
        if(keyCode==39){
          mainComponent.x=mainComponent.x+5;
          }
        else if(keyCode==37){
          mainComponent.x=mainComponent.x-5;
          }
        else if(keyCode==38){
          mainComponent.y=mainComponent.y-5;
          }
        else if(keyCode==40){
          mainComponent.y=mainComponent.y+5;
          }
        if(mainComponent.y>=470){
          mainComponent.y=470;
        }
        if(mainComponent.y<=0){
          mainComponent.y=0;
        }
        if(mainComponent.x>=500){
          mainComponent.x=-30;
        }
        if(mainComponent.x<-30){
          mainComponent.x=500;
        }
      }
      function onClick(e){
        let bullet = new Bullet(mainComponent.x-(mainComponent.width*0.7),mainComponent.y-30,29,29);
      components.push(bullet);
      }
      window.addEventListener('click',onClick);
      window.addEventListener('keydown',onKeyDown);
      function isOverlap(obj1, obj2){
        let overlap = !(obj1.x+obj1.width < obj2.x || 
                obj1.x > obj2.x+obj2.width || 
                obj1.y+obj1.height < obj2.y || 
                obj1.y > obj2.y+obj2.height);
        return overlap;
      }
    </script>
  </body>
</html>
